import numpy as np
from collections.abc import Sequence

"""
1. Петя перешел в другую школу. На уроке физкультуры ему понадобилось
определить своё место в строю. Помогите ему это сделать. Программа получает
на вход не возрастающую последовательность натуральных чисел, означающих рост
каждого человека в строю. После этого вводится число X – рост Пети.
Выведите номер, под которым Петя должен встать в строй. Если в строю есть люди
с одинаковым ростом,таким же, как у Пети, то он должен встать после них.
rank([165, 163, 162, 160, 157, 157, 155, 154], 162)  #=> 3
"""
a = [165, 163, 162, 160, 157, 157, 155, 154]
pet = 162
count = 0
for i in a:
    if i >= pet:
        count += 1
print(count + 1)


"""
2. Дан список чисел. Выведите все элементы списка, которые больше предыдущего
элемента.
[1, 5, 2, 4, 3]  #=> [5, 4]
[1, 2, 3, 4, 5] #=> [2, 3, 4, 5]
"""
a = [1, 5, 2, 4, 3]
for i in range(1, len(a)):
    if a[i] > a[i - 1]:
        print(a[i], end=" ")
print()


"""
3. Напишите программу, принимающую зубчатый массив любого типа и
возвращающего его "плоскую" копию.
List = [1, 2, [3, 4, [5, 6], 7], [8, [9, [10]]]]
"""
lst2 = [1, 2, [3, 4, [5, 6], 7], [8, [9, [10]]]]


def flatten(lst2):
    for item in lst2:
        if isinstance(item, Sequence) and not isinstance(item, str):
            yield from flatten(item)
        else:
            yield item


print(list(flatten(lst2)))


"""
4. Напишите функцию, которая принимает на вход одномерный массив и
два числа - размеры выходной матрицы. На выход программа должна подавать
матрицу нужного размера, сконструированную из элементов массива.
reshape([1, 2, 3, 4, 5, 6], 2, 3) =>
[
    [1, 2, 3],
    [4, 5, 6]
]
reshape([1, 2, 3, 4, 5, 6, 7, 8,], 4, 2) =>
[
    [1, 2],
    [3, 4],
    [5, 6],
    [7, 8]
]
"""
a = np.reshape([1, 2, 3, 4, 5, 6], (2, 3))
print(a)
a = np.reshape([1, 2, 3, 4, 5, 6, 7, 8], (4, 2))
print(a)


# Генераторы:
"""
Напишите функцию-генератор, которая вычисляет числа фибоначчи
"""


def gen_fib():
    x, y = 0, 1
    while True:
        x, y = y, x + y
        yield x


f = gen_fib()
for i in range(0, 20):
    print(next(f), end=" ")
print()


"""
Напишите генератор списка который принимает список
numbers = [34.6, -203.4, 44.9, 68.3, -12.2, 44.6, 12.7] и возвращает новый
список только с положительными числами
"""
numbers = [34.6, -203.4, 44.9, 68.3, -12.2, 44.6, 12.7]


def gen_list(numbers):
    yield [n for n in numbers if n > 0]


print(next(gen_list(numbers)), end=" ")
print()

"""
Необходимо составить список чисел которые указывают на длину слов в строке:
sentence = "the quick brown fox jumps over the lazy dog",
но только если слово не "the".
"""
sentence = "the quick brown fox jumps over the lazy dog"


def gen_count():
    lst1 = sentence.split()
    for i in lst1:
        if i != 'the':
            yield len(i)


for i in gen_count():
    print(i, end=" ")
